Subject: [Pppext] [Technical Errata Reported] RFC2759 (1924)

From: RFC Errata System <[email-masked]>
Date: Thu, 22 Oct 2009 13:16:19 -0700 (PDT)

The following errata report has been submitted for RFC2759,
"Microsoft PPP CHAP Extensions, Version 2".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata_search.php?rfc=2759&eid=1924

--------------------------------------
Type: Technical
Reported by: Alexey Melnikov <[email-masked]>

Section: 8.3

Original Text
-------------
   NtPasswordHash(
   IN  0-to-256-unicode-char Password,
   OUT 16-octet              PasswordHash )
   {
      /*
       * Use the MD4 algorithm [5] to irreversibly hash Password
       * into PasswordHash.  Only the password is hashed without
       * including any terminating 0.
       */
   }

Corrected Text
--------------
   NtPasswordHash(
   IN  0-to-256-unicode-char Password,
   OUT 16-octet              PasswordHash )
   {
      /*
       * Use the MD4 algorithm [5] to irreversibly hash Password
       * encoded in UTF-16-LE into PasswordHash.
       * Only the password is hashed without
       * including any terminating 0.
       */
   }

Notes
-----
Section 8.3 is silent on Unicode encoding used for passwords.
Section 9.2 seem to imply that the Unicode encoding used in UTF-16-LE.

Instructions:
-------------
This errata is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party (IESG)
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC2759 (draft-ietf-pppext-mschap-v2-04)
--------------------------------------
Title               : Microsoft PPP CHAP Extensions, Version 2
Publication Date    : January 2000
Author(s)           : G. Zorn
Category            : INFORMATIONAL
Source              : Point-to-Point Protocol Extensions
Area                : Internet
Stream              : IETF
Verifying Party     : IESG

---

From: James Carlson <[email-masked]>
Date: Thu, 22 Oct 2009 16:40:27 -0400

> "Microsoft PPP CHAP Extensions, Version 2".

Yes, that change is accurate.  The same issue affects the description
for GenerateNTResponse() in 8.1, GenerateAuthenticatorResponse() in 8.7,
NewPasswordEncryptedWithOldNtPasswordHash() in 8.9, and
OldNtPasswordHashEncryptedWithNewNtPasswordHash() in 8.12.  In all cases
where a "0-to-256-unicode-char Password" is used, the algorithm actually
expects 16 bit little-endian Unicode.

-- 
James Carlson         42.703N 71.076W         <[email-masked]>